import java.util.Scanner;
import java.util.Arrays;

class Card {
	int value;
	String suit;

	public final static String[] suitNames = {
		"Elf", "Man", "Hobbit", "Ent", "Ork"
	};

	public Card(int valueIn, int suitIn) {
		if (valueIn < 1 || valueIn > 21) {
			throw new RuntimeException("Illegal card value attempted." +
			" The " + "acceptible range is 1 to 21.  You tried " + valueIn);
		}
		if (suitIn < 0 || suitIn > 4) {
			throw new RuntimeException("Illegal suit attempted." +
			" The  " + "acceptible range is 0 to 4.  You tried " + suitIn);
		}

		this.suit = suitNames[suitIn];
		this.value = valueIn;
	}

	public int getValue() { return value; }
	
	public String getSuit() { return suit; }
}




public class HandDetection {

    private static boolean detectSpread(Card[] handOfCards) {
        boolean spreadFound = false;

        /* ------------------- INSERT CODE HERE ---------------------
         *
         * Your code should set the value of spreadFound appropriately.
         *
         */


        /* -------------------- END OF INSERTION --------------------*/

        return spreadFound;
    }


    private static boolean detectRainbow(Card[] handOfCards) {
		boolean rainbowFound = false;

        /* ------------------- INSERT CODE HERE ---------------------
         *
         * Your code should set the value of rainbowFound appropriately.
         *
         */


        /* -------------------- END OF INSERTION --------------------*/

		return rainbowFound;
	}

	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);

		int numOfTestCases = sc.nextInt();

		for (int testCase=0; testCase < numOfTestCases; testCase++) {
			Card[] handOfCards = new Card[5];
			for(int card=0; card<5; card++) 
			{
				int suit = sc.nextInt();
				int value = sc.nextInt();
				handOfCards[card] = new Card(value, suit);
			}
			
			if (detectSpread(handOfCards)) {
				System.out.print("Have a spread.          ");
			}
			else {
				System.out.print("Do not have a spread.   ");
			}

			if (detectRainbow(handOfCards)) {
				System.out.println("Have a rainbow.");
			}
			else {
				System.out.println("Do not have a rainbow.");
			}
		}
		
		sc.close();
	}
}

